
import com.ewon.ewonitf.IOTag;
import java.io.OutputStream;
import java.io.PrintStream;
import java.util.Date;
import javax.microedition.io.Connector;
import javax.microedition.io.file.FileConnection;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author SiDe
 */
public class DanfossXMLParser {
    
   
    static String GetVariableByTagname(String XMLString, String Node, String Address)
    {
    
        try
        {
            int posStartElt;
            int posEndElt;
            int FromIndex = 0;
            String XMLStringToProcess = XMLString;
            
            while (true)
            {               
                posStartElt = XMLString.indexOf("<val", FromIndex);
                if (posStartElt == -1)
                    return "";

                posEndElt = XMLString.indexOf("</val>", FromIndex);
                if (posEndElt == -1)
                    return "";

                XMLStringToProcess = XMLString.substring(posStartElt, posEndElt);
                
                if (XMLStringToProcess.indexOf("node=\"" + Node + "\"") != -1
                        && XMLStringToProcess.indexOf("tag=\"" + Address + "\"") != -1)
                    break;
                                
                FromIndex = posEndElt + ("</val>").length();
                                
            }
            
            String XmlAttrToGet = "parval=\"";
            int PosStart = XMLStringToProcess.indexOf(XmlAttrToGet);
                
            if (PosStart == -1)
            {
                Exception newException = new Exception("[DANFOSS][ERROR] (GetVariableByTagname): No parval attribute in xml");
                throw newException;
            }
                
            PosStart = PosStart + XmlAttrToGet.length();            
            int PosEnd = XMLStringToProcess.indexOf("\"", PosStart);
                   
            return XMLStringToProcess.substring(PosStart, PosEnd);
            
        }
        catch(Exception ex)
        {
            System.out.println("[DANFOSS][ERROR] : GetVariableByTagname() : " + ex.getMessage());
            return "";
        }
    
    }
    
    
    static String GetVariableByCIDVID(String XMLString, String Node, String CID, String VID)
    {
    
        try
        {
            int posStartElt;
            int posEndElt;
            int FromIndex = 0;
            String XMLStringToProcess = XMLString;
            
            while (true)
            {               
                posStartElt = XMLString.indexOf("<val", FromIndex);
                if (posStartElt == -1)
                    return "";

                posEndElt = XMLString.indexOf("</val>", FromIndex);
                if (posEndElt == -1)
                    return "";

                XMLStringToProcess = XMLString.substring(posStartElt, posEndElt);

                if (XMLStringToProcess.indexOf("node=\"" + Node + "\"") != -1
                        && XMLStringToProcess.indexOf("cid=\"" + CID + "\"") != -1
                        && XMLStringToProcess.indexOf("vid=\"" + VID + "\"") != -1)
                    break;
                                
                FromIndex = posEndElt + ("</val>").length();
                                
            }
                        
            String XmlAttrToGet = "parval=\"";
            int PosStart = XMLStringToProcess.indexOf(XmlAttrToGet);
                
            if (PosStart == -1)
            {
                Exception newException = new Exception("[DANFOSS][ERROR] (GetVariableByCIDVID): No parval attribute in xml");
                throw newException;
            }
                
            PosStart = PosStart + XmlAttrToGet.length();            
            int PosEnd = XMLStringToProcess.indexOf("\"", PosStart);
                   
            return XMLStringToProcess.substring(PosStart, PosEnd);
            
        }
        catch(Exception ex)
        {
            System.out.println("[DANFOSS][ERROR] : GetVariableByCIDVID() : " + ex.getMessage());
            return "";
        }    
    }
  
    
     static String GetSensor(String XMLString, String Node, String Mod, String Point)
     {
    
        try
        {
            int posStartElt;
            int posEndElt;
            int FromIndex = 0;
            String XMLStringToProcess = XMLString;
            
            while (true)
            {               
                posStartElt = XMLString.indexOf("<sensor", FromIndex);
                if (posStartElt == -1)
                    return "";

                posEndElt = XMLString.indexOf("</sensor>", FromIndex);
                if (posEndElt == -1)
                    return "";

                XMLStringToProcess = XMLString.substring(posStartElt, posEndElt);

                if (XMLStringToProcess.indexOf("node=\"" + Node + "\"") != -1
                        && XMLStringToProcess.indexOf("mod=\"" + Mod + "\"") != -1
                        && XMLStringToProcess.indexOf("point=\"" + Point + "\"") != -1)
                    break;
                                
                FromIndex = posEndElt + ("</sensor>").length();
                                
            }
                        
            String XmlAttrToGet = "parval=\"";
            int PosStart = XMLStringToProcess.indexOf(XmlAttrToGet);
                
            if (PosStart == -1)
            {
                Exception newException = new Exception("[DANFOSS][ERROR] (GetSensor): No parval attribute in xml");
                throw newException;
            }
                
            PosStart = PosStart + XmlAttrToGet.length();            
            int PosEnd = XMLStringToProcess.indexOf("\"", PosStart);
                   
            return XMLStringToProcess.substring(PosStart, PosEnd);
            
        }
        catch(Exception ex)
        {
            System.out.println("[DANFOSS][ERROR] : GetSensor() : " + ex.getMessage());
            return "";
        }    
    }
     
     static String GetMeterValue(String XMLString, String MeterId, String VarName)
     {
    
        try
        {
            int posStartElt;
            int posEndElt;
            int FromIndex = 0;
            String XMLStringToProcess = XMLString;
            
            while (true)
            {               
                posStartElt = XMLString.indexOf("<meter", FromIndex);
                if (posStartElt == -1)
                    return "";

                posEndElt = XMLString.indexOf("</meter>", FromIndex);
                if (posEndElt == -1)
                    return "";

                XMLStringToProcess = XMLString.substring(posStartElt, posEndElt);

                if (XMLStringToProcess.indexOf("id=\"" + MeterId + "\"") != -1)
                    break;
                                
                FromIndex = posEndElt + ("</meter>").length();
                                
            }
                        
            String XmlTagStartToGet = "<"+VarName+">";
            String XmlTagEndToGet = "</"+VarName+">";
            
            int PosStart = XMLStringToProcess.indexOf(XmlTagStartToGet);
                
            if (PosStart == -1)
            {
                Exception newException = new Exception("[DANFOSS][ERROR] (GetMeter): No Variable Name in xml");
                throw newException;
            }
                
            PosStart = PosStart + XmlTagStartToGet.length();            
            int PosEnd = XMLStringToProcess.indexOf(XmlTagEndToGet, PosStart);
                   
            return XMLStringToProcess.substring(PosStart, PosEnd);
            
        }
        catch(Exception ex)
        {
            System.out.println("[DANFOSS][ERROR] : GetMeter() : " + ex.getMessage());
            return "";
        }    
    }
}
